local panelExt = {}

function panelExt.Create(myDrawFunc)
local panel
  if myDrawFunc == nil then
    panel = loveframes.Create("panel")
    return panel
  end
local template = {}
template.name = "newpanel"
template.properties = {}
local oldDraw = template.properties["panel"]
template.properties["panel"] =
{
  draw = function(self) -- change the original draw routine
            local state = loveframes.state
            local selfstate = self.state
              if state ~= selfstate then
                return
              end
            local visible = self.visible
               if not visible then
                return
              end
            local children = self.children
            local skins = loveframes.skins.available
            local skinindex = loveframes.config["ACTIVESKIN"]
            local defaultskin = loveframes.config["DEFAULTSKIN"]
            local selfskin = self.skin
            local skin = skins[selfskin] or skins[skinindex]
            local drawfunc = skin.DrawPanel or skins[defaultskin].DrawPanel
            local draw = self.Draw
            local drawcount = loveframes.drawcount
            self:SetDrawOrder()
              if draw then
                draw(self)
                --newdrawfunc(self)
              else
                  myDrawFunc(self) --your routine is added here
              end
              for k, v in ipairs(children) do
                v:draw()
              end
         end
}
loveframes.templates.Register(template)
panel = loveframes.Create("panel") --create the panel with your draw routine
template.properties["panel"] =
{
  draw = function(self) -- restore the original draw routine
            local state = loveframes.state
            local selfstate = self.state
              if state ~= selfstate then
                return
              end
            local visible = self.visible
               if not visible then
                return
              end
            local children = self.children
            local skins = loveframes.skins.available
            local skinindex = loveframes.config["ACTIVESKIN"]
            local defaultskin = loveframes.config["DEFAULTSKIN"]
            local selfskin = self.skin
            local skin = skins[selfskin] or skins[skinindex]
            local drawfunc = skin.DrawPanel or skins[defaultskin].DrawPanel
            local draw = self.Draw
            local drawcount = loveframes.drawcount
            self:SetDrawOrder()
              if draw then
                draw(self)
              else
                drawfunc(self)
              end
              for k, v in ipairs(children) do
                v:draw()
              end
         end
}
loveframes.templates.Register(template)
collectgarbage()
--print(collectgarbage("count")*1024)
return panel
end
return panelExt